package com.unipi.talepis;

public class Demo {
    public static void main(String... args){
        int i;
        final int PR = 125;
        String str1 = "Maria";
        final String s2 = "Dimitris";
        String s3;
        Student o = new Student();
        System.out.println(o.hashCode());
        System.out.println(new Student().hashCode());
        System.out.println(o.hashCode());
        System.out.println(new Student().hashCode());
        System.out.println(returnStudent().hashCode());

        new Student().study();
        // Γενικός τύπος anonymous class μέσω existing Class
        // new ParentClass(Constructor Parameters){Class body}
        new Student(){
            int AFM=123456789;
            @Override
            void study() {
                System.out.println("I am not studying!...");
                System.out.println("and my AFM is "+AFM);
                System.out.println(addTwoNumbers(10,5));
            }
            int addTwoNumbers(int a, int b){
                return a+b;
            }
        }.study();
        new Student(){}.study();
        new Student(); //useless
        Student s1 = new Student();
        useStudent(s1);
        useStudent(new Student());
        useStudent(new Student(){
        });
        //-----------------------------------------------
        // Γενικός τύπος anonymous class μέσω existing Interface
        // new InterfaceName(){.....} //an anonymous class that implements an existing interface!
        new ISpeak(){
            @Override
            public void speak(String s) {
                System.out.println("Hello "+s);
            }
        }.speak("Maria");

        ISpeak someVar = new ISpeak() {
            @Override
            public void speak(String s) {

            }
        };
        someVar.speak("John");

        useISpeak(new ISpeak() {
            @Override
            public void speak(String s) {
                System.out.println("Blah blah blah "+s);
            }
        });

        new ISpeak(){
            @Override
            public void speak(String s) {
                // i = 20;  //complile error -> regular variable
                System.out.println("Helllllooooooo "+s+" "+PR);
            }
        }.speak("George");

        new Professor("Pavlos"){
        }.teach(); // with no default constructor!

        new Professor("Helen"){
            {email="helen@yahoo.com";} //instance initializer!!!
        }.teach();
    }

    static void useStudent(Student student){
        // do something with Student object
    }

    static void useISpeak(ISpeak iSpeak){
        iSpeak.speak("Unipi!");
    }

static Student returnStudent(){
        return new Student();
}

}

interface ISpeak{   //this is a functional interface
    void speak(String s);
}

interface IMark{}  //this is a marker interface

class Student{
    int age;
    String name;
    void study(){
        System.out.println("I am studying!");
    }
}

class Professor{
    private String name;
    String email;
    public Professor(String name) {
        this.name = name;
    }
    void teach(){
        System.out.println("I am teaching!");
        System.out.println("My name is "+name);
        System.out.println("My email is "+email);
    }
}
